#include <ros/ros.h>
#include <iostream>
#include <math.h>
#include <std_msgs/Float32.h>
#include <sensor_msgs/Joy.h> 
#include <geometry_msgs/Twist.h>
using namespace std;
//variable for storing the number of counts of the encoder
int counter = 0;
int totalCount = 0;
bool turnFlag = false;
bool turnFinished = false;
int terrain_type = 1;
bool turn_dreta = false;
bool turn_esquerra = false;
bool gostraight = true;
int travelled = 0;
int turns = 0;

void Enc_R_Callback(const std_msgs::Float32& msg){
    counter = msg.data;
}
void terrainCallback(const std_msgs::Float32& msg){
    terrain_type = msg.data;
}
void joyCallback (const sensor_msgs::Joy::ConstPtr& joy_data){
/* This function responds to any change on the state of the joystick. It
 * is mainly used to detect when the buttons are pressed and act according
 * the one that has been pressed
 */
	if (joy_data->buttons[5] == 1){	//this button will restart the PID
		turn_dreta = true;
	}
	if (joy_data->buttons[6] == 1){	//this button will restart the PID
		turn_esquerra = true;
	}
	if (joy_data->buttons[7] == 1){	//this button will restart the PID
		turn_esquerra = false;
	}
	if (joy_data->buttons[7] == 1){	//this button will restart the PID
		turn_dreta = false;
	}
}
void turn(){
	float threshold;
	cout << "Counter: " << counter << " totalCounter: " << totalCount << endl;
	totalCount = totalCount + counter;
	
	switch (terrain_type){
		
		case 1:
				threshold = totalpulse*2.17;
				break;
		case 2:
				threshold = totalpulse*1.805;
				break;
		case 3:
				threshold = totalpulse*2.61;
				break;
		
	}
	
	if (totalCount > threshold){
		turnFinished = true;
	}
}
int main(int argc, char** argv){

    ros::init(argc, argv, "turn90");
    ros::NodeHandle handle;
    /* Declaration of all the subscribers that will be needed during the
     * all the computations of this node*/
	ros::Subscriber I_fl = handle.subscribe("Encoder_Right", 100, Enc_R_Callback);
	ros::Subscriber joy_sub = handle.subscribe("joy",0,joyCallback);
	ros::Publisher speed = handle.advertise<geometry_msgs::Twist>("cmd_vel",0);
    geometry_msgs::Twist cmd_vel;
    ros::Subscriber terrain_type = handle.subscribe("Terrain_type",0,terrainCallback);
    ros::Rate loop_rate(20);
    while (ros::ok()){  
        

if (turn_dreta){
			int totalpulse = 2000;
			if (gostraight){
				cmd_vel.linear.x = 0.4;
				cmd_vel.angular.z = 0;
				speed.publish(cmd_vel);
				travelled = travelled + counter;
				cout << travelled << endl;
				if (travelled > 5000){
					gostraight = false;
				}
			
			}else{
				travelled = 0;
				cmd_vel.linear.x = 0.4;
				cmd_vel.angular.z = 0.4;
				speed.publish(cmd_vel);
				turn();
				if(turnFinished){
					cmd_vel.angular.z = 0;
					totalCount = 0;
					speed.publish(cmd_vel);
					turnFinished = false;
					gostraight = true;
					turns = turns + 1;
				}
			}
			if (turns == 1){
				turns = 0;
				turn_dreta = false;
			}
		}
        ros::spinOnce();
        loop_rate.sleep();
    		if (turn_esquerra){
			int totalpulse = 11500;
			if (gostraight){
				cmd_vel.linear.x = 0.4;
				cmd_vel.angular.z = 0;
				speed.publish(cmd_vel);
				travelled = travelled + counter;
				cout << travelled << endl;
				if (travelled > 5000){
					gostraight = false;
				}
			
			}else{
				travelled = 0;
				cmd_vel.linear.x = 0.4;
				cmd_vel.angular.z = -0.4;
				speed.publish(cmd_vel);
				turn();
				if(turnFinished){
					cmd_vel.angular.z = 0;
					totalCount = 0;
					speed.publish(cmd_vel);
					turnFinished = false;
					gostraight = true;
					turns = turns + 1;
				}
			}
			if (turns == 1){
				turns = 0;
				turn_esquerra = false;
			}
		}
        ros::spinOnce();
        loop_rate.sleep();
    }
    return 0;
}
